/* --- Copyright University of Sussex 1991.  All rights reserved. ---------
 > File:           C.all/lib/auto/copydata.p
 > Purpose:        recursive data structure copier
 > Author:         Roger Evans, Aug 22 1985 (see revisions)
 > Documentation:  HELP * COPYDATA
 */

section;

lconstant Prologvar_key = datakey(prolog_newvar());

define global procedure copydata(x);
	lvars key x;
	datakey(x) -> key;
	if key == Prologvar_key then
		prolog_newvar()
	elseif class_field_spec(key) then
		appdata(x,
			procedure(y);
				lvars y;
				if y == x and not(isprologvar(y)) then
					;;; Mustn't print circular structure!
					mishap(0, 'TRYING TO COPY A CIRCULAR ' sys_>< dataword(y))
				else
					copydata(y)
				endif
			endprocedure);
		if isvectorclass(x) then datalength(x) endif;
		fast_apply(class_cons(key))
	elseif isarray(x) then
		copy(x)
	else
		x
	endif
enddefine;

endsection;


/* --- Revision History ---------------------------------------------------
--- John Williams, Dec  3 1991
		Now copies arrays (cf. BR rudil.11)
--- John Williams, Jan 16 1991
		Changed -class_spec- to -class_field_spec-
--- Aaron Sloman, May 23 1986
		After correspondence with Colin Shearer - fixed to cope with
		circular structures and non-simple numbers. Should not copy undef
		objects, probably.
*/
