/*  --- Copyright University of Sussex 1986.  All rights reserved. ---------
 >  File:           C.all/lib/auto/echoload.p
 >  Purpose:        echo file as it is loaded
 >  Author:         Steven Hardy, Sep 1979 (see revisions)
 >  Documentation:  HELP * ECHOLOAD
 >  Related Files:
 */
compile_mode :pop11 +strict;

section;

global vars procedure (pause=identfn, echoload_input);


define global vars macro echoload;
	dlocal echoload_input;
	lvars last, errorflag, stack, outchar, popnl=popnewline;
	fill(initv(stacklength())) -> stack;
	true -> popnewline;
	discin(sysfileok(rdstringto([; ^termin ^newline]))) -> echoload_input;
	popnl -> popnewline;

	define dlocal pause();
		define dlocal interrupt();
			popready();
			exitfrom(pause);
		enddefine;
		until charin() == `\n then enduntil;
	enddefine;

   define dlocal interrupt();
	  true -> errorflag;
	  exitto(valof("echoload"))
   enddefine;

	cucharout -> outchar;
Errorloop:
	outchar -> cucharout;
	false -> errorflag;
	`\n -> last;
	subsystem_compile(
		procedure;
			lvars Char;
			echoload_input() -> Char;
			unless Char == termin then
				if last == `\n then
					pr(popprompt);
				endif;
				cucharout(Char);
			endunless;
			Char ->> last;
		endprocedure, "pop11");
	if errorflag then
		until last == `\n do
			echoload_input() -> last
		enduntil;
		goto Errorloop
	endif;
	while stacklength() > 0 do erase() endwhile;
	appdata(stack, identfn);
enddefine;

endsection;

/* --- Revision History ---------------------------------------------------
--- Aaron Sloman, Aug 17 1986
	Fixed so as not to need ";"
	Used lvars instead of sections
	Use echoload_input to hold character repeater
*/
