/* --- Copyright University of Sussex 1992. All rights reserved. ----------
 > File:			C.all/lib/auto/exval_to_popobj.p
 > Purpose:			Exval <-> pop object or string converters
 > Author:			John Gibson, Sep  3 1992
 > Documentation:	REF *EXTERNAL_DATA
 */
compile_mode :pop11 +strict :vm -pentch;

section;

	;;; property to hold on to fixed copies of objects
lconstant cache = newproperty([], 32, false, "tmparg");

define global exval_to_popobj(/*exptr*/) with_nargs 1;
	;;; just copy the external ptr
	copy()
enddefine;
;;;
define updaterof exval_to_popobj(obj);
	lvars obj, cached = cache(obj);
	if cached then
		cached
	elseif class_attribute(datakey(obj), "external_noconv")
	and not(is_fixed(obj)) then
		;;; structure passed directly to external call or put straight into
		;;; "exval" field -- must make fixed version
		copy_fixed(obj) ->> cache(obj)
	else
		obj
	endif
enddefine;

define global exval_to_string(/*exptr*/) with_nargs 1;
	lvars string = exacc_ntstring();
	;;; exacc_ntstring returns termin for a NULL -- we want false
	if string == termin then false else string endif
enddefine;
;;;
define updaterof exval_to_string(string);
	lvars string, cached;
	if string then
		check_string(string);
		if cache(string) ->> cached then
			cached
		elseif is_fixed(string) then
			string
		else
			copy_fixed(string) ->> cache(string)
		endif
	else
		false
	endif
enddefine;

endsection;
