/* --- Copyright University of Sussex 1993. All rights reserved. ----------
 > File:            C.all/lib/auto/line_repeater.p
 > Purpose:         Produce a line repeater for a given file
 > Author:          Aaron Sloman, Sep  9 1990 (see revisions)
 > Documentation:	REF * SYSIO/line_repeater
 > Related Files:	REF * CHARIO REF * SYS_READ_LINES, * VEDREADIN
 */

compile_mode:pop11 +strict;

section;

define global line_repeater(file, lim);
	lvars file, lim, dev, buffer;

	define lconstant Get_line(dev, buffer, lim) with_props line_repeater;
		lvars dev, buffer, lim, n;
		fast_sysread(dev, 1, buffer, lim) -> n;
		if n == 0 then
			termin
		else
			substring(1, n fi_- 1, buffer)
		endif
	enddefine;

	if isdevice(file) do
		file
	else
		sysopen(file, 0, "line", `N`)
		;;; Should also check that the device was opened in "line" mode
	endif -> dev;

	lim or 80 -> lim;
	if isstring(lim) then
		lim -> buffer;
		datalength(buffer) -> lim;
	elseif isinteger(lim) then
		inits(lim + 1) -> buffer
	else
		mishap(file, lim, 2, 'STRING (buffer) OR INTEGER (buffer size) NEEDED')
	endif;

	Get_line(% dev, buffer, lim %)
enddefine;

endsection;


/* --- Revision History ---------------------------------------------------
--- John Williams, Jan 12 1993
		Now uses ERR_CHAR `N` when opening the device. Also, ___lim may be
		false, in which case it defaults to 80.
 */
