/*  --- Copyright University of Sussex 1990.  All rights reserved. ---------
 >  File:           C.all/lib/auto/shuffle.p
 >  Purpose:        Shuffle a list.
 >  Author:         A.Sloman 1982 (see revisions)
 >  Documentation:  REF * shuffle
 >  Related Files:
 */
compile_mode :pop11 +strict;


section;

define lconstant delete_one(item, list) -> list;
	;;; delete first found copy of item from list
	;;; based on fast_ncdelete
	lvars item, next, list, temp;
	returnif(null(list));
	returnif(item == fast_front(list))(fast_back(list) -> list);

	list -> temp;
	until null((fast_back(temp) ->> next)) do
	returnif(item == fast_front(next))(fast_back(next) -> fast_back(temp));
		next -> temp
	enduntil
enddefine;

define global shuffle(list) -> result;
lvars list x result = [];
	copylist(list) -> list;
	[%
	until list == [] do
		oneof(list) ->> x;
		delete_one(x, list) -> list
	enduntil %] -> result
enddefine;

endsection;

/* --- Revision History ---------------------------------------------------
--- Aaron Sloman, Oct 25 1990
	Fixed bug reported by Andrew Casson, namely shuffle removed repeated
	elements. Other minor changes. Probably faster now.
	Added compile_mode
 */
