/* --- Copyright University of Sussex 1993. All rights reserved. ----------
 > File:            C.all/lib/proto/objectclass/auto/call_all_next_methods.p
 > Purpose:         Objectclass file
 > Author:          Steve Knight, HP Labs, 1992-1993
 > Documentation:   HELP OBJECTCLASS
 > Related Files:
 */
compile_mode :pop11 +strict;

section $-objectclass => call_all_next_methods;

define lconstant procedure fast_dl( L ); lvars L;
	until L == [] do
		fast_destpair( L ) -> L
	enduntil
enddefine;

define lconstant procedure do_call_all_next_methods( L ); lvars L;
	dlocal CallNextMethodProcs;
	until CallNextMethodProcs == [] do
		( fast_destpair( CallNextMethodProcs ) -> CallNextMethodProcs )( fast_dl( L ) )
	enduntil;
enddefine;

define updaterof do_ucall_all_next_methods( L ); lvars L;
	dlocal UCallNextMethodProcs;
	until UCallNextMethodProcs == [] do
		( fast_destpair( UCallNextMethodProcs ) -> UCallNextMethodProcs )( fast_dl( L ) )
	enduntil;
enddefine;

define global syntax call_all_next_methods;
	unless MethodName do
		mishap( 'CALL_ALL_NEXT_METHODS: MUST BE USED INSIDE A METHOD', [] )
	endunless;

	if MethodMode == UCALL_MODE then
		true -> CurrentProperties( "invokes_ucall_next_method" );
	else
		true -> CurrentProperties( "invokes_call_next_method" );
	endif;

	pop11_need_nextreaditem( "(" ).erase;
	sysPUSH( "popstackmark" );
	pop11_comp_expr_seq_to( ")" ).erase;
	sysCALL( "sysconslist" );
	sysCALLQ( apply_mode( do_call_all_next_methods, MethodMode ) );

	if pop_expr_update then
		mishap( 'CALL_ALL_NEXT_METHODS NO LONGER HAS UPDATE MODE', [^MethodName] )
	endif;

enddefine;

endsection;

;;; -------------------------------------------------------------------------
;;; Modified, 3/6/93, sfk
;;;     *   Removed explicit update mode for call_all_next_methods.
;;;         Now uses MethodMode.
;;;     *   Fixed 2 long-standing bugs in update mode of call_all_next_methods.
;;;         (It incorrectly used CallNextMethodProcs)
;;; -------------------------------------------------------------------------
;;; Modified, 6/10/93, JJC
;;;     *   removed checking for pop_oc_version < 6.
;;; -------------------------------------------------------------------------
