/* --- Copyright University of Sussex 1993. All rights reserved. ----------
 > File:            C.all/lib/proto/objectclass/auto/call_next_method.p
 > Purpose:         Objectclass file
 > Author:          Steve Knight, HP Labs, 1992-1993
 > Documentation:   HELP OBJECTCLASS
 > Related Files:
 */
compile_mode :pop11 +strict;

section $-objectclass => call_next_method;

define lconstant procedure Do_call_next_method();
	dlocal CallNextMethodProcs;
	if CallNextMethodProcs == [] then
		mishap( 'CALL_NEXT_METHOD: no next method', [] )
	else
		( fast_destpair( CallNextMethodProcs ) -> CallNextMethodProcs )()
	endif;
enddefine;

;;; So the (U)CALL_MODE technique works.  Not a true updater.
;;;
define updaterof Do_call_next_method();
	dlocal UCallNextMethodProcs;
	if UCallNextMethodProcs == [] then
		mishap( 'CALL_NEXT_METHOD: no next update-method', [] )
	else
		( fast_destpair( UCallNextMethodProcs ) -> UCallNextMethodProcs )()
	endif;
enddefine;

define global syntax call_next_method;
	unless MethodName do
		mishap( 'CALL_NEXT_METHOD: must be used inside a method', [] )
	endunless;

	true -> CurrentProperties( "invokes_call_next_method" );
	pop11_need_nextreaditem( "(" ).erase;
	pop11_comp_expr_seq_to( ")" ).erase;
	sysCALLQ( apply_mode( Do_call_next_method, MethodMode ) );

	;;; If prior to version 6.0, we will allow the code to compile
	;;; in update mode.
	if pop_expr_update then
			mishap( 'CALL_NEXT_METHOD NO LONGER HAS UPDATE MODE', [^MethodName] )
	endif;
enddefine;

endsection;

;;; -------------------------------------------------------------------------
;;; Modified, 3/6/93, sfk
;;;     *   Removed explicit update mode for call_next_method.
;;;     *   Deleted superfluous declarations for (U)CallNextMethodProcs.
;;; -------------------------------------------------------------------------
;;; Modified, 4/6/93, sfk
;;;     *   Softend check for updater mode use of call_next_method.
;;;         Will be outlawed by version 6.0.
;;; -------------------------------------------------------------------------
;;; Modified, 6/10/93, JJC
;;;     *   removed checking for pop_oc_version < 6.
;;; -------------------------------------------------------------------------
