/* --- Copyright University of Sussex 1993. All rights reserved. ----------
 > File:            C.all/lib/proto/objectclass/auto/define_generic.p
 > Purpose:         Objectclass file
 > Author:          Steve Knight, HP Labs, 1992-1993
 > Documentation:   HELP OBJECTCLASS
 > Related Files:
 */
section $-objectclass => define_generic;

;;; I want this visible for debugging.
constant procedure generic_load_table =
	newproperty( [], 16, false, "tmparg" );

define check_generic( name, value ); lvars name, value;
	if value.isgeneric then
		lvars f = generic_load_table( value );
		if f and f /= popfilename then
			warning( 'ocgpd: GENERIC PROCEDURE ALREADY DECLARED IN ANOTHER FILE', [^name ^f] )
		endif;
		popfilename -> value.generic_load_table;
	elseunless value.isundef then
		warning( 'ocgpn: GENERIC PROCEDURE WAS DEFINED AS NON-METHOD', [^name ^value] )
	endif
enddefine;

define :define_form global generic;
	dlocal MethodName, MethodMode, InLocals, OutLocals, InClasses;
	lvars idecs, odecs;

	pop11_try_nextreaditem( "updaterof" ).flag_to_mode -> MethodMode;

	lvars decl = read_identspec( default_default_idspec() );
	readitem() -> MethodName;

	define_hook( "generic", MethodName );

	identspec_declare( decl )( MethodName, "procedure" );
	if pop11_try_nextreaditem( "(" ) then
		"(" :: proglist -> proglist;

		get_ilocals() -> ( idecs, InLocals, InClasses );
		check_ilocals( InLocals, InClasses, "generic" );
		read_olocals() -> ( odecs, OutLocals );
	else
		false -> InLocals;
		false -> OutLocals;
	endif;

	lvars with_stuff = read_with_stuff();
	pop11_try_nextreaditem( ";" ).erase;

	lvars arity =
		with_stuff( "with_nargs" ) or
		InLocals and InLocals.length or
		"unbound";

	if with_stuff( "with_combination" ) then
		;;; This is where we deal with before & after methods.
		warning( 'UNIMPLEMENTED FEATURE with_combination', [] )
	endif;

	bind_method( MethodName, MethodMode );
	lvars m = currentval( MethodName );
	check_generic( MethodName, m );
	lvars mt = method_table( m );
	if MethodMode == CALL_MODE then
		arity -> cArityMethodTable( mt );
		if with_stuff( "pdprops" ) then
			with_stuff( "pdprops" ) -> pdprops( m )
		endif;
	else
		arity -> uArityMethodTable( mt );
		if with_stuff( "pdprops" ) then
			mishap( 'USING WITH_PDPROPS IN UPDATEROF', [] )
		endif
	endif;

	pop11_need_nextreaditem( "enddefine" ).erase;
enddefine;

endsection;
