/* --- Copyright University of Sussex 1993. All rights reserved. ----------
 > File:            C.all/lib/proto/objectclass/auto/define_wrapper.p
 > Purpose:         Objectclass file
 > Author:          Steve Knight, HP Labs, 1992-1993
 > Documentation:   HELP OBJECTCLASS
 > Related Files:
 */
section $-objectclass => define_wrapper;

define wrapMethodTable( wrap, mode, path, generic ); lvars procedure wrap, mode, path, generic;
	lvars field = check_mode( mode ) == UCALL_MODE and uEntriesMethodTable or cEntriesMethodTable;
	path.truncate_path -> path;
	lvars e = method_entry( path, generic.method_table, field );
	if e then
		lvars a = actionEntry( e );
		if a.isprocedure then
			wrap(% a %) -> actionEntry( e )
		elseif a.isxslot then
			;;; Have to promote slot!
			lvars G = newgeneric( '(' sys_>< xslot_name( a ) sys_>< ')' );
			update_method( a, mode, [% path.explode %], G );
			wrap(%
				mode.check_mode == CALL_MODE and G or G.updater
			%) -> actionEntry( e )
		else
			internal_error()
		endif;
	else
		mishap( 'ocnw:FOUND NO METHOD TO WRAP', [^generic] )
	endif;
enddefine;

define wrap_method( wrap, mode, classes, generic ); lvars wrap, mode, classes, generic;
	generic.detrace_generic -> generic;
	check_classes( classes );
	unlink_method( generic );
	lvars path = classes.destlist.consvector;
	wrapMethodTable( wrap, mode, path, generic );
	if mode.check_mode == CALL_MODE then
		lvars u = updater( wrap );
		if u then
			wrap_method( u, UCALL_MODE, classes, generic )
		endif;
	endif;
enddefine;

define :define_form global wrapper;
	dlocal InLocals, InClasses, OutLocals;
	lvars idecs, odecs;

	lvars mode = pop11_try_nextreaditem( "updaterof" ).flag_to_mode;
	lvars name = readitem();
	get_ilocals() -> ( idecs, InLocals, InClasses );

	unless length( InLocals ) >= 1 do
		mishap( 'WRAPPER MUST HAVE ARGUMENTS', [^name] );
	endunless;
	if InClasses.last then
		mishap( 'WRAPPER MUST NOT RESTRICT FINAL ARGUMENT', [^name] )
	endif;

	read_olocals() -> ( odecs, OutLocals );
	lvars ( nargs, props ) = read_nargs_and_props();

	pop11_need_nextreaditem( ";" ).erase;
	sysPROCEDURE( props, nargs or InLocals.length );
	applists_n( InLocals, idecs, 2, apply );
	applists_n( OutLocals, odecs, 2, apply );
	applist( InLocals, sysPOP );
	pop11_comp_stmnt_seq_to( "enddefine" ).erase;
	sysLABEL( "return" );
	applist( OutLocals, sysPUSH );
	lvars p = sysENDPROCEDURE();

	wrap_method(
		p,
		mode,
		tl( InClasses.deref_classes ),
		name.currentval
	);
enddefine;

endsection;
