/* --- Copyright University of Sussex 1993. All rights reserved. ----------
 > File:            C.all/lib/proto/objectclass/setup/loadobjectclass.p
 > Purpose:         Objectclass file
 > Author:          Steve Knight, HP Labs, 1992-1993
 > Documentation:   HELP OBJECTCLASS
 > Related Files:
 */



;;; -- Top-level loading file -----------------------------------------------

section $-objectclass => pop_oc_version;

;;; We want some description of the loading process if pop_debugging
;;; is true and we aren't inside a call to "uses".
;;;
define lconstant procedure want_chat();
	pop_debugging == true and
	not( testdef useslib and iscaller( weakref useslib ) )
enddefine;

if want_chat() then
	nprintf( ';;; ObjectClass %p', [^(pop_oc_version/1000.0s0)] );
endif;

procedure();
	dlocal current_directory = objectclass_dir dir_>< 'src/';
	dlocal cucharout;
	unless pop_debugging == true then
		erase -> cucharout
	endunless;
	compile( 'setup.p' );
endprocedure();

if want_chat() then
	nprintf( ';;; ObjectClass %p loaded', [^(pop_oc_version/1000.0s0)] );
endif;

endsection;

;;; -------------------------------------------------------------------------
;;; Modified, 23/10/92, sfk
;;;     *   Removed the sysprotect of "class_make" which has been removed
;;;         from the system.
;;; -------------------------------------------------------------------------
;;; Modified, 25/4/92, sfk
;;;     *   added sysprotects for selected identifiers which simplifies
;;;         the declarations in the main body.  It also makes testing
;;;         easier.
;;; -------------------------------------------------------------------------
;;; Modified, 15/04/93, sfk
;;;     *   Removed sysprotects from this file.  They were out of date
;;;         and difficult to keep synchronised with changes in the
;;;         implementation.
;;; -------------------------------------------------------------------------
;;; Modified, 1/7/93, sfk
;;;     *   Stopped the loading process from chatting when objectclass
;;;         is loaded via "uses".  Doesn't matter about "lib", though,
;;;         because "lib" chats anyway.
;;; -------------------------------------------------------------------------
;;; Modified, 6/10/93, JJC
;;;     *   Modified version printing + other minor mods before installing
;;;         in Poplog 14.5
;;; -------------------------------------------------------------------------
