/* --- Copyright University of Sussex 1993. All rights reserved. ----------
 > File:            C.all/lib/proto/objectclass/setup/setenvobjectclass.p
 > Purpose:         Objectclass file
 > Author:          Steve Knight, HP Labs, 1992-1993 (see revisions)
 > Documentation:   HELP OBJECTCLASS
 > Related Files:
 */


;;; -- Set the working environment ------------------------------------------

compile_mode :pop11 +strict;

constant pop_oc_version = 1000;

;;; Make it work with uses.
global vars objectclass = true;

uses ved_src;   ;;; for extend_searchlist(... vedsrchlist)

lconstant objclass_lib = objectclass_dir dir_>< 'lib/';
lconstant objclass_auto = objectclass_dir dir_>< 'auto/';

;;; Load and show from objectclass directory
extend_searchlist(objclass_lib, popuseslist) -> popuseslist;
extend_searchlist( objclass_auto, popautolist ) -> popautolist;

;;; And extend ved's teach and help and ref lists
;;; do doc and ref, but at present teach and help suffice
lconstant
	objclass_teach = [% objectclass_dir dir_>< 'teach' % teach],
	objclass_help = [% objectclass_dir dir_>< 'help' % help],
	objclass_ref = [% objectclass_dir dir_>< 'ref' % ref],
	objclass_teachlist = [^objclass_teach ^objclass_help ^objclass_ref],
	objclass_helplist = [^objclass_help ^objclass_teach ^objclass_ref],
	objclass_reflist = [^objclass_ref ^objclass_help ^objclass_teach],
	objclass_srclist = [[% objectclass_dir dir_>< 'src' % src]],
;

extend_searchlist(ident objclass_helplist, vedhelplist) -> vedhelplist;
extend_searchlist(ident objclass_teachlist, vedteachlist) -> vedteachlist;
extend_searchlist(ident objclass_reflist, vedreflist) -> vedreflist;
extend_searchlist(ident objclass_srclist, vedsrclist) -> vedsrclist;


/* --- Revision History ---------------------------------------------------
--- Integral Solutions Ltd, Oct  8 1993
		Modified version to be integer
 */
