/* --- Copyright University of Sussex 1993. All rights reserved. ----------
 > File:            C.all/lib/proto/objectclass/src/bind_method.p
 > Purpose:         Objectclass file
 > Author:          Steve Knight, HP Labs, 1992-1993
 > Documentation:   HELP OBJECTCLASS
 > Related Files:
 */
compile_mode :pop11 +strict;

section $-objectclass;

define bind_method( mname, mode ); lvars mname, mode;
	lvars id = sys_current_ident( mname );
	if mode.check_mode == UCALL_MODE then
		if id then
			unless id.idval.detrace_generic.isgeneric do
				mishap( 'DEFINING UPDATER OF METHOD OF NON-METHOD', [^mname] )
			endunless
		else
			mishap( 'DEFINING UPDATEROF METHOD BEFORE THE METHOD IS DECLARED', [^mname] )
		endif;
	elseif id then
		lvars previous = detrace_generic( idval( id ) );
		if
			previous.isundef or
			id.isconstant and           ;;; catch lconstants
			id.isassignable and
			id.isident /== "perm"
		then
			sysPASSIGN( newgeneric( mname ), mname );
		elseunless previous.isgeneric then
			warning( 'PREVIOUS VALUE WAS NOT A METHOD', [^mname] );
			sysPASSIGN( newgeneric( mname ), mname );
		endif
	else
		internal_error()
	endif;
enddefine;


endsection;

;;; -------------------------------------------------------------------------
;;; Modified, 30/05/93, sfk
;;;     *   Completely rewritten in line with new compilation strategy
;;;         for classes.
;;; -------------------------------------------------------------------------
