/* --- Copyright University of Sussex 1993. All rights reserved. ----------
 > File:            C.all/lib/proto/objectclass/src/class_construct.p
 > Purpose:         Objectclass file
 > Author:          Steve Knight, HP Labs, 1992-1993
 > Documentation:   HELP OBJECTCLASS
 > Related Files:
 */
compile_mode :pop11 +strict;

section $-objectclass => class_construct;

global vars procedure isobjectclass;

define check_oc( k ) -> k; lvars k;
	unless k.isobjectclass do
		mishap( 'OBJECTCLASS NEEDED (excludes mixins/singletons)', [^k] )
	endunless
enddefine;

;;; Has to be vars because of memoisation.
define do_class_construct( key ); lvars key;
	lvars wrappers = class_cons_wrapper( key );
	lvars c = class_cons( key );
	seq_to_closure( c, wrappers )
enddefine;

constant procedure Memo_class_construct = memofn( do_class_construct <> newindirect );

define appclass_construct( p ); lvars p;
	applist( property_domain( Memo_class_construct ), p )
enddefine;

define relink_all_class_construct();
	procedure( c ); lvars c;
		do_class_construct( c ) -> indirect_pdpart( Memo_class_construct( c ) )
	endprocedure.appclass_construct
enddefine;

sysunprotect( "class_construct" );

define global class_construct( k ); lvars k;
	Memo_class_construct( k.check_oc )
enddefine;

define updaterof class_construct( p, k ); lvars p, k;
	p -> Memo_class_construct( k.check_oc );
enddefine;


sysprotect( "class_construct" );

endsection;
