/* --- Copyright University of Sussex 1994. All rights reserved. ----------
 > File:            C.all/lib/proto/objectclass/src/class_isa.p
 > Purpose:         Objectclass file
 > Author:          Steve Knight, HP Labs, 1992-1993 (see revisions)
 > Documentation:   HELP OBJECTCLASS
 > Related Files:
 */
;;; -- class_isa ------------------------------------------------------------
compile_mode :pop11 +strict;

section $-objectclass => class_isa;

;;; data is a pair with
;;;     front = false | list of inferior keys
;;;     back  = the key for which the closure was linked
define lconstant procedure Is_a( x, data ); lvars x, i, data, v, k;
	if fast_front( data ) ->> v then
		datakey( x ) -> k;
		lvars i;
		fast_for i from 1 to datalength( v ) do
			if fast_subscrv( i, v ) == k then
				return( true );
			endif;
		endfor;
		false;
	else
		if trace_matches( "link" ) then
			printf( ';;; compiling Is_a-predicate %p\n', [% data.back.class_name %] )
		endif;
		consvector(#| all_infs( [% back( data ) %] ) |#) -> front( data );
		fast_chain( x, data, Is_a );
	endif
enddefine;

;;; Has to be vars procedure because of memoisation.
sysunprotect( "class_isa" );
define global vars procedure class_isa( K ) -> H; lvars K, H;
	Is_a(% conspair( false, K ) %) -> H;
	derive_ako_name( class_name( K ) ) -> pdprops( H );
enddefine;
memofn( class_isa ) -> class_isa;
sysprotect( "class_isa" );

define lconstant procedure isunlinked_isa( H ); lvars H;
	H.isclosure and
	H.datalength == 1 and
	H.pdpart == Is_a and
	frozval( 1, H ).ispair and
	not( frozval( 1, H ).front )
enddefine;

define appisas( p ); lvars p;
	applist( property_range( class_isa ), p );
enddefine;

define_lconstant_procedure Unlink_isa( v ); lvars v;
	if front( frozval( 1, v ) ) then
		if trace_matches( "link" ) then
			printf( ';;; UNlinking isa-procedure %p\n', [% frozval( 1, v ).back.class_name %] )
		endif;
		false -> front( frozval( 1, v ) )
	endif;
enddefine;

define unlink_all_isas();
	Unlink_isa.appisas;
enddefine;

endsection;

;;; -------------------------------------------------------------------------
;;; Modified by sfk, 9/11/92
;;;     *   removed sys_grbg_list from appisas after paranoid fantasy
;;;         explained by Chris Dollin.
;;; -------------------------------------------------------------------------
;;; Modified, 10/12/92, sfk
;;;     *   Removed superfluous code for reasoning about singletons thanks
;;;         to the singletonclass revision.
;;;     *   Corrected the pdprops for the "isaXXX" procedure.  This got
;;;         zapped by an incautious edit back in version 5.04.
;;; -------------------------------------------------------------------------
;;; Modified, 15/04/93, sfk
;;;     *   Added explicit sys(un)protect to exported identifiers.
;;; -------------------------------------------------------------------------

/* --- Revision History ---------------------------------------------------
--- Integral Solutions Ltd, Sep  1 1994 (Julian Clinton)
		Modified debugging info to use class_name instead of
		class_dataword.
 */
