/* --- Copyright University of Sussex 1993. All rights reserved. ----------
 > File:            C.all/lib/proto/objectclass/src/fail_generic.p
 > Purpose:         Objectclass file
 > Author:          Steve Knight, HP Labs, 1992-1993
 > Documentation:   HELP OBJECTCLASS
 > Related Files:
 */
;;; -- Handle the failure of a method ---------------------------------

compile_mode :pop11 +strict;

section $-objectclass => fail_generic;

define_lconstant_procedure Report_failure( m, md ); lvars m, md;
	lvars arity = pdnargs( m );
	lvars args = conslist( min( stacklength(), arity ) );
	mishap(
		consstring(#|
			procedure();
				dlocal cucharout = identfn;
				printf(
					'Method "%p" %pfailed',
					[% m.pdprops, if md then 'updater ' else nullstring endif %],
				);
			endprocedure()
		|#),
		args
	);
enddefine;

define :method vars fail_generic( I, G ); lvars I, G;
	Report_failure( I, G, false )
enddefine;

define :method updaterof fail_generic( I, G ); lvars I, G;
	Report_failure( I, G, true )
enddefine;

define failure();
	chain( caller( 1 ), fail_generic )
enddefine;

define updaterof failure();
	chain( caller( 1 ), updater( fail_generic ) )
enddefine;

endsection;
