/* --- Copyright University of Sussex 1993. All rights reserved. ----------
 > File:            C.all/lib/proto/objectclass/src/plant_utils.p
 > Purpose:         Objectclass file
 > Author:          Steve Knight, HP Labs, 1992-1993
 > Documentation:   HELP OBJECTCLASS
 > Related Files:
 */
section $-objectclass;

;;; -- Compile-time dynamic variables ---------------------------------------

;;; This is bound to either <false> or a vector of variable names (or
;;; <false>) holding previously computed keys.
;;;
vars Keyargs;                   ;;; Used as a DLOCAL variable.


;;; -- Utilities ------------------------------------------------------------

define plant_method_failure( mode ); lvars mode;
	sysCALLQ( apply_mode( failure, mode ) )
enddefine;

define push_arg( level ); lvars level;
	lvars ka;
	if Keyargs and Keyargs( level ) ->> ka then
		sysPUSH( ka )
	else
		sysSUBSCR_STACK( level );
		sysCALLQ( datakey );
	endif
enddefine;

define plant_callq( p ); lvars p;
	if p then sysPUSHQ( p ) endif;
	sysCALL( "fast_chain" )
enddefine;

define slot_for_key( key, slot ); lvars key, slot;
	lvars mode = slot.isuslot and UCALL_MODE or CALL_MODE;
	lvars posn = xslot_posn( key, slot );
	lvars A = class_access( posn, key );
	lvars L = class_access_wrapper( key );
	if mode.check_mode == UCALL_MODE then
		[%
			lvars i;
			for i in L do
				if i.updater then i.updater endif
			endfor
		%] -> L;
		A.updater -> A;
	endif;
	lvars p = seq_to_closure( A, L );
	return( mode, posn, p == A, p )
enddefine;

endsection;
