/* --- Copyright University of Sussex 1993. All rights reserved. ----------
 > File:            C.all/lib/proto/objectclass/src/setup.p
 > Purpose:         Objectclass file
 > Author:          Steve Knight, HP Labs, 1992-1993
 > Documentation:   HELP OBJECTCLASS
 > Related Files:
 */
;;; -- Load the Objectclass system ------------------------------------------

compile_mode :pop11 +strict;

uses applynum;
#_IF pop_internal_version >= 141000
	;;; Used in utils.p to access typespec utilities.
	uses typespec_utils;
#_ENDIF

load preferences.p
load indirect.p
load utils.p
load readutils.p
load derive.p
load globals.p
load phantoms.p
load tmpvecs.p

load slots.p
load parts.p
load sort_classes.p
load method_table.p
load methods.p
load upgrade_method.p
load bind_method.p
load method_form.p
load define_method.p
load fail_generic.p

load seq_to_closure.p
load wrappers.p
load class_construct.p
load class_new.p
load class_example.p
load objectclasses.p

load trees.p
load net_to_tree.p
load dispatch_call_next_method.p
load plant_utils.p
load mono_tree.p
load tree_to_pd.p
load instantiate.p
load relink_method.p
load interpreter.p
load full_methods.p

load class_isa.p
load class_attributes.p
load objectclass_form.p

;;; -------------------------------------------------------------------------
;;; Modified, 23/10/92, sfk
;;;     *   Removed class_make.p -- no longer required with class_make
;;;         being made obsolete in version 5.00.
;;; -------------------------------------------------------------------------
