/* --- Copyright University of Sussex 1993. All rights reserved. ----------
 > File:            C.all/lib/proto/objectclass/src/wrappers.p
 > Purpose:         Objectclass file
 > Author:          Steve Knight, HP Labs, 1992-1993
 > Documentation:   HELP OBJECTCLASS
 > Related Files:
 */
compile_mode :pop11 +strict;

section $-objectclass;

constant procedure class_cons_wrapper =
	newanyproperty(
		[], 20, 1, false,
		false, false, "tmparg",
		[], false
	);
"class_cons_wrapper" -> pdprops( class_cons_wrapper );

constant procedure class_new_wrapper =
	copy( class_cons_wrapper );
"class_new_wrapper" -> pdprops( class_new_wrapper );

constant procedure class_access_wrapper =
	copy( class_cons_wrapper );
"class_access_wrapper" -> pdprops( class_access_wrapper );

constant wrapper_types =
	[^class_new_wrapper ^class_cons_wrapper ^class_access_wrapper];

define vars procedure add_wrapper( class, supers, wrap, class_wrapper ); lvars class, supers, wrap, class_wrapper;
	lvars sofar = wrap.rev;
	lvars c, w;
	for c in supers do
		for w in c.class_wrapper do
			 unless fast_lmember( w, sofar ) do
				conspair( w, sofar ) -> sofar
			 endunless
		endfor;
	endfor;
	sofar.rev -> class_wrapper( class );
enddefine;


endsection;

;;; -------------------------------------------------------------------------
;;; Modified, 9/12/92, jonm & sfk
;;;     *   Improved performance for wrappers of apply.
;;; -------------------------------------------------------------------------
;;; Modified, 10/12/92, sfk
;;;     *   Removed superfluous code in singletonclass revision,
;;;         at version 5.05.
;;; -------------------------------------------------------------------------
;;; Modified, 11/04/92, sfk
;;;     *   Altered call to seq_to_closure.
;;; -------------------------------------------------------------------------
;;; Modified, 2/7/93, sfk
;;;     *   Corrected defect in the treatement of updaters in
;;;         plant_call_accessor.
;;; -------------------------------------------------------------------------
