/* --- Copyright University of Sussex 1989.  All rights reserved. ---------
 >  File:           C.all/lib/ved/term/vedbbc.p
 >  Purpose:        Set ved for a 'DUMB' BBC vt52-compatible micro
 >  Author:         A.Sloman/A.Richomme ??? (see revisions)
 >  Documentation:  HELP *VT52
 >  Related Files:  LIB *VEDBBCSCREEN *VEDBBCKEYS
 */
compile_mode :pop11 +strict;

/*
Adapted July 1983 for use on BBC Micro (with Sussex University
VT52 and Tektronix Emulation chip)             by Alan Richomme.


Set VED for a 'DUMB' BBC VT52-compatible micro, i.e. no insert line,
no delete line, no character insert, no character delete, no graphic
characters, no special functions on numeric keypad,
only one function key F0 (='GOLD')

This file should be loaded before invoking VED if the user is working on
a BBC terminal. For a user who always use such a terminal, this can
be most conveniently done by putting instructions to load this file in
either INIT.P or VEDINIT.P

Instead, run-time can be saved by creating a saved image, using SYSSAVE,
which can be invoked by POP11/BBC if the saved image file is called
BBC.PSV

*/


uses-by_name vedbbckeys, vedbbcscreen;

section;

define vars vedbbc();
	veduseterm("bbc") -> ;
	identfn -> vedbbc;
enddefine;

if iscaller(vedsetup) then vedbbc() endif;

endsection;

/* --- Revision History ---------------------------------------------------
--- Jason Handby, Sep 14 1989
		Separated into "vedbbcscreen.p" and "vedbbckeys.p" files
*/
