/*	--- Copyright University of Sussex 1989.  All rights reserved. ---------
 > File:			C.all/lib/ved/term/vedbbcvt100keys.p
 > Purpose:			Ved library for bbc micro with vt100 termulator
 > Author:			Unknown, installed by Tom Khabaza, Oct 29 1985 (see revisions)
 > Documentation:	HELP * BBCVT100
 > Related Files:	LIB *BBCVT100SCREEN *BBCVT100
 */
compile_mode :pop11 +strict;

uses vedvt100keys;

section;

define lconstant vedshell();
	dlocal vedargument = '%';
	ved_obey();
enddefine;

define vedbbcvt100keys();

	vedvt100keys();

	`O` -> vedquery;

	/* GOLD arrow keys. GOLD function key is assumed to transmit <ESC> O P */

	vedset keys
		charup              = esc [ A
		charleft 	        = esc [ D
		charright	        = esc [ C
		chardown   	        = esc [ B
		nextline            = esc O w
		nextline            = esc cr
		nextline            = esc cr
		wordleft            = esc O u
		wordright           = esc O q
		charuplots          = esc esc [ A
		charleftlots        = esc esc [ D
		charrightlots       = esc esc [ C
		chardownlots        = esc esc [ B
		textleft            = esc O P esc esc [ D
		textright           = esc O P esc [ C
		lineabove           = esc O P esc [ A
		linebelow           = esc O P esc [ B
		screenup            = esc O Q
		screenleft          = esc O P esc [ D
		screenright         = esc O P esc esc [ C
		screendown          = esc O t
		topfile             = esc esc O Q
		endfile             = esc esc O t
		wordleftdelete      = esc O y   ;;; <SHIFT> F3-F9
		wordrightdelete     = esc O v
		clearhead           = esc O P esc O u
		cleartail           = esc O P esc O q
		linedelete          = esc O s
		popkey              = esc O P del  ;;; <GOLD><DEL>
		pushkey             = esc O P bs   ;;; <GOLD><COPY>
		"enterkey"          = esc O n
		ENTER pop           = esc O P esc O P
		ENTER xup           = esc O P esc O Q
		ENTER xdn           = esc O P esc O t
		ENTER da            = esc O P esc O R
		ENTER lcp           = esc O P esc O p
		"ENTER yankc"       = esc O P esc O n
		"ENTER yankw"       = esc esc O u
		"ENTER yankl"       = esc esc O w
		"ENTER yank"        = esc esc O R
		ENTER mcp           = esc esc O p
		ENTER copy          = esc O R
		ENTER m             = esc O r
		ENTER d             = esc O l
		ENTER t             = esc O m
		"ENTER cut"         = esc del
		"ENTER splice"      = esc bs
		marklo              = esc O p
		markhi              = esc O S
		statusswitch        = esc esc O n
		charup <> textleft  = esc O P esc esc [ A
		nextline <> textleft= esc O P esc esc [ B
		setstatic           = esc O P esc O r
		exchangeposition    = esc O P cr   ;;; <GOLD><RET>
		docommand           = esc O M
		refresh             = bs
		shell				= esc esc O P
	endvedset

enddefine;

endsection;


/*	--- Revision History ---------------------------------------------------
--- Jason Handby, Jul 12 1988 - split into separate files and changed to use
	vedset notation
--- Ben Rubinstein, Oct 12 1986  - vedenter, vedredo indirected through ..key
--- Mark Rubinstein, Feb 14 1986 - cleaned up some more.
--- Mark Rubinstein, Nov  8 1985 - made public
--- Mark Rubinstein, Dec 12 1984 - tidied up.
*/
