/*  --- Copyright University of Sussex 1995.  All rights reserved. ---------
 >  File:           C.all/lib/ved/ved_cc.p
 >  Purpose:        Display information about current character
 >  Author:         A.Sloman 1982 (see revisions)
 >  Documentation:	HELP * VEDCOMMS/ved_cc
 >  Related Files:  LIB *VED_IC
 */
compile_mode:pop11 +strict;

section;

define vars ved_cc;
	lvars dc = vedcurrentdchar(), c = dc && 16:FF, l;

	lconstant
		names = [
			`\s`	'space'
			`\t`	'tab'
			`\Nt`	'trailing newline'
			`\St`	'trailing space'
			`\Sf`	'format-control space'
			`\Sp`	'prompt-marker space'
			`\Ss`	'Ved no-break space'
			`\Sn`	'ISO Latin no-break space'
			`\^?`	'DEL'
		],

		graph_names = [
			`\Gle` 'leftend'
			`\Gre` 'rightend'
			`\Gte` 'topend'
			`\Gbe` 'bottomend'

			`\Gtl` 'topleft'
			`\Gtr` 'topright'
			`\Gbl` 'bottomleft'
			`\Gbr` 'bottomright'

			`\Glt` 'lefttee'
			`\Grt` 'righttee'
			`\Gtt` 'toptee'
			`\Gbt` 'bottomtee'

			`\G-`  'horizontal'
			`\G|`  'vertical'
			`\G+`  'cross'

			`\Go`  'degree'
			`\G#`  'diamond'
			`\G.`  'dot'
		];

	vedputmessage(consstring(#|
		explode('CODE = '),
		dest_characters(c),
		explode(', i.e. '),
		if fast_lmember(c, names) ->> l then
			explode(subscrl(2, l))
		elseif fast_lmember(c, graph_names) ->> l then
			explode('GRAPH '), explode(subscrl(2, l))
		elseif c < `\s` then
			explode('CTRL '), c + `@`
		else
			 `"`, c, `"`
		endif;

		if dc /== c then
			explode(' (ATTR = '),
			if dc &&/=_0 `\[b]` then explode('bold,') endif,
			if dc &&/=_0 `\[u]` then explode('underline,') endif,
			if dc &&/=_0 `\[i]` then explode('italic,') endif,
			if dc &&/=_0 `\[f]` then explode('blink,') endif,
			if dc &&/=_0 `\[7]` then
				explode('colour '),
				((dc && `\[7]`) >> #_< integer_leastbit(`\[7]`) >_#) + `0`,
				`,`
			endif,
			() -> ;
			`)`
		endif
	|#))
enddefine;

endsection;


/*  --- Revision History ---------------------------------------------------
--- John Gibson, Jan 20 1995
		Added `\Nt` (trailing newline)
--- John Gibson, Feb 21 1992
		Rewritten to show graphics characters and attributes
 */
