/* --- Copyright University of Sussex 1992. All rights reserved. ----------
 > File:            C.all/lib/ved/ved_ls.p
 > Purpose:         VED interface to Unix "ls" command
 > Author:          Aaron Sloman, December 1983 (see revisions)
 > Documentation:   HELP * LS
 > Related Files:   LIB * VED_DIR (VMS equivalent), LIB * VED_PURGE, LIB * VED_DEL
 */

section;

#_IF hd(sys_os_type) == "vms"

define global ved_ls();
	vederror('Please use <ENTER> DIR instead')
enddefine;

#_ELSE  /* Unix */

define global vars vedlsdefaults();
	vedveddefaults();
	false ->> vedcompileable ->> vedwriteable ->> vedbreak -> vednotabs;
	8 -> vedindentstep
enddefine;

define global ved_ls();
	lvars shell;
	unless (systranslate('SHELL') ->> shell) do
		vedputmessage('$SHELL not defined - using /bin/sh');
		'/bin/sh' -> shell
	endunless;
	vedpipein(
		shell,
		[% sys_fname_name(shell), '-ce', vedcommand %],
		#_< systmpfile(false, 'ved_ls', nullstring) >_#,
		vedlsdefaults,
		1,
		false)
enddefine;

#_ENDIF

endsection;


/* --- Revision History ---------------------------------------------------
--- John Williams, Nov 17 1992
		Completely rewritten, using vedpipein, to match new version of
		LIB * VED_DIR
 */
