/* --- Copyright University of Sussex 1989. All rights reserved. ----------
 > File:            C.all/lib/ved/ved_noul.p
 > Purpose:         Cleaning up underlining from MAN files
 > Author:          John Williams, Apr  7 1989 (see revisions)
 > Documentation:
 > Related Files:   LIB * VED_MAN
 */

section;

/* Removes underscore followed by backspace,
	or backspace followed by anything
*/

define global ved_noul();
	lvars bs c i j line sl;
	stacklength() -> sl;
	fast_for i from 1 to datalength(vedbuffer) do
		fast_subscrv(i, vedbuffer) -> line;
		false -> bs;
		fast_for j from 1 to datalength(line) do
			fast_subscrs(j, line) -> c;
			if c == `\b`
			or c == `_` and fast_subscrs(j fi_+ 1, line) == `\b` then
				true -> bs;
				j fi_+ 1 -> j
			else
				c
			endif;
		endfast_for;
		if bs then
			sysanyvecons(sl, consstring) -> fast_subscrv(i, vedbuffer)
		else
			setstacklength(sl)
		endif
	endfast_for;
	vedsetlinesize();
	vedrefresh()
enddefine;


endsection;


/* --- Revision History ---------------------------------------------------
--- John Williams, Apr  7 1989
		Completely re-written
 */
