/* --- Copyright University of Sussex 1989. All rights reserved. ----------
 > File:            C.all/lib/ved/ved_smr.p
 > Purpose:         Sort a marked range of text
 > Author:          Aaron Sloman, May 29 1985 (see revisions)
 > Documentation:   HELP * VEDCOMMS
 > Related Files:
 */

section;

define global ved_smr;
	lvars top;
	dlocal vedline, vedcolumn, vveddump, vvedlinesize;
	vedmarkfind();
	vedline -> top;
	ved_d();
	if vedargument = '-f' then
		syssort(vveddump, procedure(l1, l2);
							  lvars l1 l2;
							  alphabefore(mapdata(l1, uppertolower),
										  mapdata(l2, uppertolower))
						  endprocedure)
	else
		syssort(vveddump, alphabefore)
	endif -> vveddump;
	(top - 1) sys_>< nullstring -> vedargument;
	ved_y();
	'SORTED' -> vedmessage
enddefine;

endsection;



/* --- Revision History ---------------------------------------------------
--- John Gibson, Jan  4 1989
		Replaced -vednullstring- with -nullstring-
--- John Williams, Apr 23 1986
		 If vedargument = '-f' it folds uppercase onto lowercase
*/
