/* --- Copyright University of Sussex 1989. All rights reserved. ----------
 > File:            C.all/lib/ved/ved_wiggle.p
 > Purpose:         Automatic bracket wiggling utility
 > Author:          John Williams, Oct 21 1988 (see revisions)
 > Documentation:   HELP * LISPVED
 > Related Files:   C.all/lib/ved/ved_wmp.p
 */


section;

global vars vedwiggling = true;

define lconstant Vdfiletype();
	sys_fname_extn(vedcurrent)
enddefine;

define lconstant Vdautowiggle(filetypes);
	lvars filetypes;
	vedinsertvedchar();
	if vedwiggling
	and not(vedonstatus)
	and fast_member(Vdfiletype(), filetypes) do
		procedure();
			dlocal vedcolumn;
			vedcharleft();
			ved_wmp()
		endprocedure()
	endif
enddefine;


define global vars ved_wiggle();
	lvars bra filetype filetypes key pdr
	;
	if vedargument = nullstring then
		chain('set vedwiggling', veddo)
	endif
	;
	unless datalength(vedargument) == 2 do
		vederror('Two "bracket" characters needed (e.g. [])')
	endunless;
	fast_subscrs(2, vedargument) -> bra;
	consstring(bra, 1) -> key
	;
	vednormaltable(bra) -> pdr;
	if pdpart(pdr) == Vdautowiggle then
		if isinheap(pdr) then pdr else copy(pdr) endif
	elseunless pdr == vedinsertvedchar do
		vederror('Cannot make "' <> key <> '" a wiggly key')
	else
		Vdautowiggle(% [] %)
	endif -> pdr
	;
	Vdfiletype() -> filetype;
	fast_frozval(1, pdr) -> filetypes;
	if member(filetype, filetypes) then
		'The "' <> key <> '" key reset for',
		ncdelete(filetype, filetypes, sys_=)
	else
		'The "' <> key <> '" key set for',
		filetype :: filetypes
	endif -> filetypes -> vedmessage
	;
	if null(filetypes) then
		vedinsertvedchar -> pdr;
		vedmessage <> ' all file types'
	else
		filetypes -> fast_frozval(1, pdr);
		vedmessage <> '\s' <> filetype <> ' files'
	endif -> vedmessage
	;
	vedsetkey(key, pdr)
enddefine;


endsection;


/* --- Revision History ---------------------------------------------------
--- John Gibson, Aug  4 1989
		Now uses -sys_fname_extn- instead of -sysfiletype-
 */
