/* --- Copyright University of Sussex 1994. All rights reserved. ----------
 > File:            C.all/lisp/flib/f_escape.p
 > Purpose:         LIB * FORMAT_PRINT ~^ directive
 > Author:          John Williams, Nov  2 1994 (see revisions)
 > Documentation:   HELP * FORMAT_PRINT
 > Related Files:   LIB * FORMAT_PRINT
 */

uses format_print;

section $-lisp$-fpr;

/* Ensure ~[ and ~{ loaded */

f_proc(`[`) ->;
f_proc(`{`) ->;


/* Code for ~^ directive */

procedure (x, y, z);
	lvars x, y, z, do_exit;
	if x then
		if y then
			if z then
				(z > y) and (y > x)
			else
				x = y
			endif
		else
			x = 0
		endif
	else
		f_arg_index >= f_arg_len
	endif -> do_exit;
	if do_exit then
		if f_colon and fl_sublists == true then
			exitfrom(do_loop)
		elseif f_endchar == `]` then
			false -> fc_doit
		endif;
		false -> f_doit
	endif
endprocedure -> f_proc(`^`);


endsection;


/* --- Revision History ---------------------------------------------------
--- John Williams, Dec 16 1994
		No longer nees to check f_endchar == `>`
 */
