/* --- Copyright University of Sussex 1995. All rights reserved. ----------
 > File:            C.all/lisp/flib/f_justify.p
 > Purpose:         LIB * FORMAT_PRINT ~< ... ~> directive
 > Author:          John Williams, Nov  2 1994 (see revisions)
 > Documentation:   HELP * FORMAT_PRINT
 > Related Files:   LIB * FORMAT_PRINT
 */

uses format_print;
include ved_declare.ph;

section $-lisp$-fpr;

unless isdefined("fbuffer") do
	syslibcompile("fbuffer", f_liblist) ->
endunless;


lvars Fj_buff_i = 0, Fj_1st_clause = false, Fj_linemax;


define lconstant Linemax();
	if testdef vedprocess and weakref[vedprocess] vedediting then
		weakref[vedprocess] vedlinemax
	else
		poplinemax
	endif
enddefine;


define make_fj_clause(x, y);        /* This is called by ~; in f_clause.p */
	lvars x, y, str;
	if f_doit then
		substring(Fj_buff_i + 1, fbuffer_i - Fj_buff_i, fbuffer) -> str;
		if f_colon and not(Fj_1st_clause) then
			str -> Fj_1st_clause;
			defaults x 0;
			defaults y (Linemax());
			y - x -> Fj_linemax
		else
			fbuffer_i -> Fj_buff_i;
			str
		endif
	endif
enddefine;


define lconstant Read_fj_clauses();
	lvars i = fbuffer_i;
	dlocal
		f_at,
		f_colon,
		f_doit,
		Fj_buff_i = i,
		cucharout = fbuffer_charout,
		fbuffer_i,
		;
	next_f_char();
	do_fpr();
	false ->> f_colon -> f_at;
	make_fj_clause(false, false);
	fbuffer_i fi_- i
enddefine;


procedure(w, colinc, minpad, padchar);
	lvars w, colinc, minpad, padchar,
			nclauses, nchars, nspaces, ngaps, nbig, nsmall,
			leftsp, clauses, big_gap, small_gap;

	dlocal f_endchar = `>`, Fj_linemax, Fj_1st_clause = false;
	defaults w 0, colinc 1, minpad 0, padchar `\s`;

	check_positive(w);
	check_positive(colinc);
	check_positive(minpad);

	[% Read_fj_clauses() -> nchars %] -> clauses;

	returnunless(f_doit);

	listlength(clauses) -> nclauses;
	nclauses fi_- 1 -> ngaps;
	if nclauses == 1 and not(f_at) then
		true -> f_colon
	endif;
	if f_colon then
		ngaps fi_+ 1 -> ngaps
	endif;
	if f_at then
		ngaps fi_+ 1 -> ngaps
	endif;
	round(max(w fi_- (ngaps fi_* minpad) fi_- nchars, 0) / colinc) -> nspaces;

	if Fj_1st_clause
	and (Fj_linemax fi_- f_charout_col())
			fi_<
		(nchars fi_+ (nspaces * colinc))
	then
		cuch_string(Fj_1st_clause)
	endif;

	nspaces fi_// ngaps -> small_gap -> nbig;
	ngaps fi_- nbig -> nsmall;
	minpad fi_+ (small_gap fi_* colinc) -> small_gap;
	small_gap fi_+ colinc -> big_gap;
	if f_colon then
		if nbig == 0 then
			nsmall fi_- 1 -> nsmall, small_gap
		else
			nbig fi_- 1 -> nbig, big_gap
		endif
	else
		0
	endif -> leftsp;
	cuch_chars(leftsp, padchar);
	repeat nbig times
		cuch_string(fast_destpair(clauses) -> clauses);
		cuch_chars(big_gap, padchar)
	endrepeat;
	repeat nsmall times
		cuch_string(fast_destpair(clauses) -> clauses);
		cuch_chars(small_gap, padchar)
	endrepeat;
	unless clauses == nil do
		cuch_string(fast_front(clauses))
	endunless
endprocedure -> f_proc(`<`);


check_need_bracket(% `>` %) -> f_proc(`>`);


endsection;


/* --- Revision History ---------------------------------------------------
--- John Williams, Jun  1 1995
		weakref'd references to Ved vars.
--- John Williams, Dec 16 1994
		Re-written using fbuffer_charout.
 */
