/* --- Copyright University of Sussex 1995. All rights reserved. ----------
 > File:			C.all/lisp/flib/f_loop.p
 > Purpose:			LIB * FORMAT_PRINT ~{ ... ~} directive
 > Author:			John Williams, Oct 16 1985 (see revisions)
 > Documentation:   HELP * FORMAT_PRINT
 > Related Files:   LIB * FORMAT_PRINT
 */

uses format_print;

section $-lisp$-fpr;

vars fl_start, fl_end, fl_once, fl_more, fl_sublists;


define lconstant Read_fl_string() -> finish -> f_colon;
	lvars finish, nested;
	dlocal f_doit, f_syntax, f_colon, f_at;
	false -> f_doit;
	not -> f_syntax;
	1 -> nested;
	until nested == 0 do
		if (locchar(`~`, f_str_index, f_string) ->> f_str_index) then
			false ->> f_colon -> f_at;
			parse_directive();
			if f_char == `{` then
				nested fi_+ 1 -> nested
			elseif f_char == `}` then
				nested fi_- 1 -> nested;
			endif
		else
			mishap(f_string, 1, 'Missing Closing ~}')
		endif
	enduntil;
	f_str_index fi_- (2 fi_+ (if f_colon then 1 else 0 endif)
						fi_+ (if f_at then 1 else 0 endif)) -> finish
enddefine;


define do_loop() with_props false;
	dlocal f_string;
	if fl_start == fl_end then
		next_f_arg() -> f_string;
		1 -> fl_start;
		false -> fl_end
	endif;
	defaults fl_more (f_arg_len fi_- f_arg_index);
	if fl_once then
		if fl_sublists then
			do_fpr_args(f_string, next_f_arg(), fl_start, fl_end)
		else
			do_fpr_string(f_string, fl_start, fl_end)
		endif;
		fl_more fi_- 1 -> fl_more
	endif;
	repeat fl_more times
		quitif(f_arg_index == f_arg_len);
		if fl_sublists then
			do_fpr_args(f_string, next_f_arg(), fl_start, fl_end)
		else
			do_fpr_string(f_string, fl_start, fl_end)
		endif
	endrepeat
enddefine;


procedure(fl_more);
	dlocal f_doit, fl_start, fl_end, fl_once, fl_more, fl_sublists;
	next_f_char();
	f_str_index -> fl_start;
	f_colon -> fl_sublists;
	Read_fl_string() -> fl_end -> fl_once;
	unless fl_more == 0 do
		if f_at then
			do_loop()
		else
			procedure(f_args);
				dlocal f_args, f_arg_len, f_arg_index;
				if islist(f_args) then
					{% dl(f_args) %} -> f_args
				elseunless isvector(f_args) do
					mishap(f_args, 1, 'List or Vector Needed')
				endif;
				0 -> f_arg_index;
				datalength(f_args) -> f_arg_len;
				do_loop()
			endprocedure(next_f_arg())
		endif
	endunless
endprocedure -> f_proc(`{`);


f_error(% 'Unexpected Closing Bracket' %) -> f_proc(`}`);


endsection;


/* --- Revision History ---------------------------------------------------
--- John Williams, May 25 1995
		Tidied up variable declarations (parameters are now lvars by default).
 */
