/* --- Copyright University of Sussex 1995. All rights reserved. ----------
 > File:			C.x/x/pop/lib/Xm/xmTextWidget.p
 > Purpose:			Motif widgetclass
 > Author:			John Gibson, Apr 14 1993 (see revisions)
 > Documentation:	HELP * MOTIF
 > Related Files:	Xm/xm*Widget.p etc
 */
compile_mode :pop11 +strict;

section;
exload_batch;

include xpt_coretypes.ph;
include XmConstants.ph;

uses Xmgeneral;

XptLoadWidgetClass xmTextWidget [^^XM_EXLIBS]
	xmTextWidget	<- xmTextWidgetClass,
;

define XmIsText =
	XtIsSubclass(% xmTextWidget %)
enddefine;

;;; strings returned from the Text widget are copies, so we must free
;;; them after copying the contents
define lconstant CopyString(exptr) -> string;
	lvars exptr, string;
	if is_null_external_ptr(exptr) then
		;;; may be for XmTextGetSelection
		false -> string;
	else
		exacc_ntstring(exptr) -> string;
		fast_XtFree(exptr);
	endif;
enddefine;
;;;
l_typespec CopyString :exptr.CopyString;

XptPopLoadProcedures ''
	XmCreateScrolledText(parent,name,arglist,argcount) :XptWidget,
	XmCreateText(parent,name,arglist,argcount) :XptWidget,
	XmTextClearSelection(widget,time) :void,
	XmTextCopy(widget,time) :XptBoolean,
	XmTextCut(widget,time) :XptBoolean,
	XmTextGetAddMode(widget) :XptBoolean,
	XmTextGetBaseLine(widget) :int,
	XmTextGetBaseline(widget) :int,
	XmTextGetCursorPosition(widget) :XmTextPosition,
	XmTextGetEditable(widget) :XptBoolean,
	XmTextGetInsertionPosition(widget) :XmTextPosition,
	XmTextGetLastPosition(widget) :XmTextPosition,
	XmTextGetMaxLength(widget) :int,
	XmTextGetSelection(widget) :CopyString,
	XmTextGetSelectionPosition(widget,left,right) :XptBoolean,
	XmTextGetSource(widget) :XmTextSource,
	XmTextGetString(x) :CopyString,
	XmTextGetTopCharacter(widget) :XmTextPosition,
	XmTextInsert(widget,position,value) :void,
	XmTextPaste(widget) :XptBoolean,
	XmTextPosToXY(widget,position,x,y) :XptBoolean,
	XmTextRemove(widget) :XptBoolean,
	XmTextReplace(widget,from_pos,to_pos,value) :void,
	XmTextScroll(widget,lines) :void,
	XmTextSetAddMode(widget,state) :void,
	XmTextSetCursorPosition(widget,position) :void,
	XmTextSetEditable(widget,editable) :void,
	XmTextSetHighlight(widget,left,right,mode) :void,
	XmTextSetInsertionPosition(widget,position) :void,
	XmTextSetMaxLength(widget,length) :void,
	XmTextSetSelection(widget,first,last,time) :void,
	XmTextSetSource(widget,source,top_character,cursor_position) :void,
	XmTextSetString(widget,value) :void,
	XmTextSetTopCharacter(widget,top_character) :void,
	XmTextShowPosition(widget,position) :void,
	XmTextXYToPos(widget,x,y) :XmTextPosition,

#_IF XM_VERSION >= 1002
	XmTextDisableRedisplay(widget) :void,
	XmTextEnableRedisplay(widget) :void,
	XmTextFindString(widget,start,string,direction,position) :XptBoolean,
	XmTextGetSubstring(widget,start,num_chars,buffer_size,buffer) :int,
#_ENDIF
;

endexload_batch;
endsection;


/* --- Revision History ---------------------------------------------------
--- Robert John Duncan, Jun 23 1995
		Changed XmTextGetString and XmTextGetSelection to free the returned
		string as soon as it's been copied. Added new 1.2 functions.
 */
